﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Xna_codecamp_v2.Objects
{
    class Board
    {
        private List<Node> nodeList;
        private Node[,] nodeMap;
        private Vector2[,] coordiMap;
        
        //private Dictionary<Node, Vector2> node_coordi = new Dictionary<Node,Vector2>();


        public List<Node> getNodeList()
        {
            return nodeList;
        }

        public Board()
        {
            //Creating the board object
            nodeList = new List<Node>();
            nodeMap = new Node[7, 9];
            Node t;
            Vector2 c;

            coordiMap = new Vector2[7, 9];

           

            //Constructing and populating the default board


            //Constructing and populating the default board
            t = new Node(Definitions.clear, new GamePiece(Definitions.lion, Definitions.Player1));
            nodeList.Add(t);
            nodeMap[0, 0] = t;
            
            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[1, 0] = t;

            t = new Node(Definitions.trap, null);
            nodeList.Add(t);
            nodeMap[2, 0] = t;

            t = new Node(Definitions.nest, null);
            t.owner = Definitions.Player1;
            nodeList.Add(t);
            nodeMap[3, 0] = t;

            t = new Node(Definitions.trap, null);
            nodeList.Add(t);
            nodeMap[4, 0] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[5, 0] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.tiger, Definitions.Player1));
            nodeList.Add(t);
            nodeMap[6, 0] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[0, 1] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.dog, Definitions.Player1));
            nodeList.Add(t);
            nodeMap[1, 1] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[2, 1] = t;

            t = new Node(Definitions.trap, null);
            nodeList.Add(t);
            nodeMap[3, 1] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[4, 1] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.cat, Definitions.Player1));
            nodeList.Add(t);
            nodeMap[5, 1] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[6, 1] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.rat, Definitions.Player1));
            nodeList.Add(t);
            nodeMap[0, 2] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[1, 2] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.leopard, Definitions.Player1));
            nodeList.Add(t);
            nodeMap[2, 2] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[3, 2] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.wolf, Definitions.Player1));
            nodeList.Add(t);
            nodeMap[4, 2] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[5, 2] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.elephant, Definitions.Player1));
            nodeList.Add(t);
            nodeMap[6, 2] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[0, 3] = t;

            t = new Node(Definitions.water, null);
            nodeList.Add(t);
            nodeMap[1, 3] = t;

            t = new Node(Definitions.water, null);
            nodeList.Add(t);
            nodeMap[2, 3] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[3, 3] = t;

            t = new Node(Definitions.water, null);
            nodeList.Add(t);
            nodeMap[4, 3] = t;

            t = new Node(Definitions.water, null);
            nodeList.Add(t);
            nodeMap[5, 3] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[6, 3] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[0, 4] = t;

            t = new Node(Definitions.water, null);
            nodeList.Add(t);
            nodeMap[1, 4] = t;

            t = new Node(Definitions.water, null);
            nodeList.Add(t);
            nodeMap[2, 4] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[3, 4] = t;

            t = new Node(Definitions.water, null);
            nodeList.Add(t);
            nodeMap[4, 4] = t;

            t = new Node(Definitions.water, null);
            nodeList.Add(t);
            nodeMap[5, 4] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[6, 4] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[0, 5] = t;

            t = new Node(Definitions.water, null);
            nodeList.Add(t);
            nodeMap[1, 5] = t;

            t = new Node(Definitions.water, null);
            nodeList.Add(t);
            nodeMap[2, 5] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[3, 5] = t;

            t = new Node(Definitions.water, null);
            nodeList.Add(t);
            nodeMap[4, 5] = t;

            t = new Node(Definitions.water, null);
            nodeList.Add(t);
            nodeMap[5, 5] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[6, 5] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.elephant, Definitions.Player2));
            nodeList.Add(t);
            nodeMap[0, 6] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[1, 6] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.wolf, Definitions.Player2));
            nodeList.Add(t);
            nodeMap[2, 6] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[3, 6] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.leopard, Definitions.Player2));
            nodeList.Add(t);
            nodeMap[4, 6] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[5, 6] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.rat, Definitions.Player2));
            nodeList.Add(t);
            nodeMap[6, 6] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[0, 7] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.cat, Definitions.Player2));
            nodeList.Add(t);
            nodeMap[1, 7] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[2, 7] = t;

            t = new Node(Definitions.trap, null);
            nodeList.Add(t);
            nodeMap[3, 7] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[4, 7] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.dog, Definitions.Player2));
            nodeList.Add(t);
            nodeMap[5, 7] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[6, 7] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.tiger, Definitions.Player2));
            nodeList.Add(t);
            nodeMap[0, 8] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[1, 8] = t;

            t = new Node(Definitions.trap, null);
            nodeList.Add(t);
            nodeMap[2, 8] = t;

            t = new Node(Definitions.nest, null);
            t.owner = Definitions.Player2;
            nodeList.Add(t);
            nodeMap[3, 8] = t;

            t = new Node(Definitions.trap, null);
            nodeList.Add(t);
            nodeMap[4, 8] = t;

            t = new Node(Definitions.clear, null);
            nodeList.Add(t);
            nodeMap[5, 8] = t;

            t = new Node(Definitions.clear, new GamePiece(Definitions.lion, Definitions.Player2));
            nodeList.Add(t);
            nodeMap[6, 8] = t;

            linker();
  
            //initialize the coordiMap
            for (int i = 0; i < 7; i++)
            {
                for (int j = 0; j < 9; j++)
                {
                    float x = 196 + i * 60;
                    float y = 36 + j * 60;
                    c = new Vector2(x, y);
                    coordiMap[i, j] = c;
                }
            }
        

        }


        //Linker, called from the board (links the nodes to their neighbours and sets their coordinates)
        private void linker()
        {
            Node temp;
            for (int i = 0; i < 7; i++)
            {
                for (int j = 0; j < 9; j++)
                {
                    temp = nodeMap[i, j];
                    temp.x = i;
                    temp.y = j;

                    if (j > 0)
                        temp.addNeighbour(Definitions.up, nodeMap[i, j - 1]);
                    if (j < 8)
                        temp.addNeighbour(Definitions.down, nodeMap[i, j + 1]);
                    if (i > 0)
                        temp.addNeighbour(Definitions.left, nodeMap[i - 1, j]);
                    if (i < 6)
                        temp.addNeighbour(Definitions.right, nodeMap[i + 1, j]);
                }
            }
            return;
        }


        public Node getSquare(int x, int y)
        {
            if (x < 0 || x > 6 || y > 8 || y < 0)
                throw new ArgumentException("Out of bounds!");
            else
                return nodeMap[x, y];
        }

        public Vector2 getCoordi(int x, int y)
        {
            return coordiMap[x, y];
        }

        public int game_logic(GamePiece gp, Node nd, int x, int y)
        {

            //game piece move to next node
            GamePiece temp;
            //node isn't empty
            if (!nd.isEmpty() && gp.getTrapValue() != Definitions.isTrapped)
            {
                //game piece type is larger than the one on that node
                if (gp.type == Definitions.elephant &&
                    nd.getContentType() != Definitions.rat &&
                    gp.type >= nd.getContentType() &&
                    gp.player != nd.getContent().player)
                {
                    getSquare(x, y).removePiece();
                    temp = nd.removePiece();
                    nd.addPiece(gp);
                    return Definitions.killed;
                }
                else if (gp.type != Definitions.elephant &&
                    gp.type >= nd.getContentType() &&
                    gp.player != nd.getContent().player)
                {
                    getSquare(x, y).removePiece();
                    temp = nd.removePiece();
                    nd.addPiece(gp);
                    return Definitions.killed;
                }
                //rat kill elephant
                else if (gp.type == Definitions.rat && nd.getContentType() == Definitions.elephant)
                {
                    getSquare(x, y).removePiece();
                    temp = nd.removePiece();
                    nd.addPiece(gp);
                    return Definitions.killed;
                }
                else if (gp.player == nd.getContent().player)
                {
                    return Definitions.blocked;
                }
                else if (nd.getContent().getTrapValue() == Definitions.isTrapped)
                {
                    getSquare(x, y).removePiece();
                    temp = nd.removePiece();
                    gp.setTrapValue(Definitions.isTrapped);
                    nd.addPiece(gp);
                    return Definitions.killed;
                }
                else return Definitions.blocked;

            }
            //node is empty, then check if the piece can move to there
            else if (nd.isEmpty() && gp.getTrapValue() != Definitions.isTrapped)
            {
                //only rat can enter the water zone
                if (nd.type == Definitions.water && gp.type == Definitions.rat)
                {
                    getSquare(x, y).removePiece();
                    nd.addPiece(gp);
                    return Definitions.moved;
                }
                else if (nd.type == Definitions.clear)      //all animal can enter a clear zone
                {
                    getSquare(x, y).removePiece();
                    nd.addPiece(gp);
                    return Definitions.moved;
                }
                else if (nd.type == Definitions.trap)      //an animal enters a trap
                {
                    getSquare(x, y).removePiece();
                    nd.addPiece(gp);
                    gp.setTrapValue(Definitions.isTrapped);
                    return Definitions.moved;
                }
                else if (nd.type == Definitions.nest)      //an animal enters a nest
                {
                    getSquare(x, y).removePiece();
                    nd.addPiece(gp);
                    if ((nd.owner == Definitions.Player2 && gp.player == Definitions.Player1) ||
                        (nd.owner == Definitions.Player1 && gp.player == Definitions.Player2))
                    {
                        return Definitions.inNest;
                    }
                    else return Definitions.moved;
                }
                else return Definitions.blocked;
            }
            else
            {
                getSquare(x, y).getContent().setTrapValue(Definitions.notTrapped);
                return Definitions.blocked;
            }

        }









    }
}
